from flask import Flask, render_template, request, redirect, url_for, session
from config import api_key
from requests import get
from datetime import datetime
from json import dumps, loads
from subprocess import Popen
app = Flask(__name__)
app.secret_key = 'hejrwfkjewhrjewkrhewkjrhwjkdbs'

MAX_PLAYERS = 100

def  check_valid_phone_num(number:int):
    if len(str(number)) == 10:
        return True
    return False

def check_ign(ign:str):
    player = get(f"https://eun1.api.riotgames.com/lol/summoner/v4/summoners/by-name/{ign}?api_key={api_key}")
    if player.status_code == 200:
        return True
    return False  


class Players:
    def __init__(self) -> None:
        with open('players.json', 'r') as f:
            self.players = loads(f.read())

    def check_if_player_exists(self, ign:str):
        if ign in self.players.keys():
            return True
        return False
    
    def add_player(self, ign:str, phone:int):
        if not self.check_if_player_exists(ign):
            self.players[ign] = phone
            with open('players.json', 'w') as f:
                f.write(dumps(self.players))
            return True
        return False

    
@app.route('/', methods=['GET', 'POST'])
def index():
    return render_template('index.html', players=Players().players)

@app.route('/success/')
def success():
    return render_template('success.html')

@app.route('/create/', methods=['GET', 'POST'])
def create():
    if len(Players().players)>=MAX_PLAYERS:
        return render_template('max_players.html')
    if request.method == 'POST':
        session['ign'] = request.form['ign']
        session['phone'] = request.form['phone']
        if check_valid_phone_num(session['phone']) and check_ign(session['ign']):
            Players().add_player(session['ign'], session['phone'])
            return redirect(url_for('success'))
        else:
            return redirect(url_for('index'))
    return render_template('create.html')


def main():
    lol = Popen(['python','playoffs.py'])
    app.run(debug=True, port=5000)

if __name__ == '__main__':
    main()